﻿using System.Data;
using System.Windows.Forms;

using SampleApplication.Data;
using SampleApplication.BaseDataInterface;

namespace SampleApplication.BaseController
{
    public class DetailBaseController2<DS, DT, DR, TK, SC> : SampleApplication.BaseController.BaseController
		where DS : DataSet
		where DT : DataTable
		where DR : DataRow
		where TK : DataTableKeys
		where SC : SearchCondition
	{
		private DS _dataSet;
		public DS DataSet
		{
			get { return _dataSet; }
			set { _dataSet = value; }
		}

		private DT _dataTable;
		public DT DataTable
		{
			get { return _dataTable; }
			set { _dataTable = value; }
		}

		private BindingSource _bindingSource;
		public BindingSource BindingSource
		{
			get { return _bindingSource; }
			set { _bindingSource = value; }
		}

		private IBaseTableAdapterInterface<DT, DR, TK, SC> _tableAdapterInterface;
		public IBaseTableAdapterInterface<DT, DR, TK, SC> TableAdapterInterface
		{
			get { return _tableAdapterInterface; }
			set { _tableAdapterInterface = value; }
		}

		private ITableAdapterInterface _baseTableAdapterInterface;
		public ITableAdapterInterface BaseTableAdapterInterface
		{
			get { return _baseTableAdapterInterface; }
			set { _baseTableAdapterInterface = value; }
		}

        public void InitializeController(DS dataSet, DT dataTable, BindingSource bindingSource,
			IBaseTableAdapterInterface<DT, DR, TK, SC> tableAdapterInterface, ITableAdapterInterface baseTableAdapterInterface)
        {
            _dataSet = dataSet;
            _dataTable = dataTable;
            _bindingSource = bindingSource;
            _tableAdapterInterface = tableAdapterInterface;
			_baseTableAdapterInterface = baseTableAdapterInterface;
        }

        public DetailBaseController2<DataSet, DataTable, DataRow, DataTableKeys, SearchCondition> GetBaseController()
        {
            DetailBaseController2<DataSet, DataTable, DataRow, DataTableKeys, SearchCondition> baseController =
				new DetailBaseController2<DataSet, DataTable, DataRow, DataTableKeys, SearchCondition>();
            baseController.DataSet = _dataSet;
            baseController.DataTable = _dataTable;
            baseController.BindingSource = _bindingSource;
			baseController.TableAdapterInterface = _baseTableAdapterInterface;
            return baseController;
        }

		public virtual bool AddNew()
		{
			BindingSource.AddNew();
			return true;
		}

		public virtual bool LoadData(TK keys)
		{
			if (keys == null) return AddNew();
			TableAdapterInterface.FillTableByKeys(DataTable, keys);
			return true;
		}

		public virtual bool Save()
		{
			BindingSource.EndEdit();
			TableAdapterInterface.UpdateTable(DataTable);
			return true;
		}

		public virtual bool Delete()
		{
			BindingSource.RemoveCurrent();
			TableAdapterInterface.UpdateTable(DataTable);
			return true;
		}
	}
}
