﻿using System.Data;
using SampleApplication.DataInterface;
using SampleApplication.BaseDataInterface;
namespace SampleApplication.Data 
{
	partial class ユーザーDataSet
	{
		public class ユーザーDataTableKeys : DataTableKeys
		{
			public int ID;
			public ユーザーDataTableKeys(int id)
			{
				this.ID = id;
			}
		}
		public class ユーザーSearchCondition : SearchCondition
		{
			public string 姓;
			public string 名;
			public string ユーザー名;
			public string 都道府県;
			public string 市町村;
			public string 電話番号;

			public ユーザーSearchCondition( 
				string 姓,
				string 名,
				string ユーザー名,
				string 都道府県,
				string 市町村,
				string 電話番号)
			{
				this.姓 = 姓;
				this.名 = 名;
				this.ユーザー名 = ユーザー名;
				this.都道府県 = 都道府県;
				this.市町村 = 市町村;
				this.電話番号 = 電話番号;
			}
		}
	}
}
namespace SampleApplication.Data.ユーザーDataSetTableAdapters
{
	partial class ユーザーTableAdapter : ユーザーTableAdapterInterface, ITableAdapterInterface
	{
		protected override void Dispose(bool disposing)
		{
			if (disposing)
			{
				Mnow.Data.DAHelper.Dispose(this.Adapter, this._connection, this._commandCollection);
			}
			base.Dispose(disposing);
		}
		public void FillTable(DataTable table)
		{
			this.Fill((ユーザーDataSet.ユーザーDataTable)table);
		}
		public void UpdateTable(DataTable table)
		{
			this.Update((ユーザーDataSet.ユーザーDataTable)table);
		}
		public void FillTableByKeys(DataTable table, DataTableKeys keys)
		{
			this.FillByKeys((ユーザーDataSet.ユーザーDataTable)table, ((ユーザーDataSet.ユーザーDataTableKeys)keys).ID);
		}
		public DataTableKeys GetKeys(DataRow row)
		{
			return new ユーザーDataSet.ユーザーDataTableKeys(((ユーザーDataSet.ユーザーRow)row).ID);
		}
		public void FillTableBySearch(DataTable table, SearchCondition condition)
		{
			ユーザーDataSet.ユーザーSearchCondition _condition = (ユーザーDataSet.ユーザーSearchCondition)condition;
			this.FillBySearch((ユーザーDataSet.ユーザーDataTable)table,
				_condition.姓, _condition.名, _condition.ユーザー名,
				_condition.都道府県, _condition.市町村, _condition.電話番号);
		}

		#region IBaseTableAdapterInterface<ユーザーDataTable,ユーザーRow,ユーザーDataTableKeys,ユーザーSearchCondition> メンバ

		void SampleApplication.BaseDataInterface.IBaseTableAdapterInterface<ユーザーDataSet.ユーザーDataTable, ユーザーDataSet.ユーザーRow, ユーザーDataSet.ユーザーDataTableKeys, ユーザーDataSet.ユーザーSearchCondition>.FillTable(ユーザーDataSet.ユーザーDataTable table)
		{
			this.Fill(table);
		}

		void SampleApplication.BaseDataInterface.IBaseTableAdapterInterface<ユーザーDataSet.ユーザーDataTable, ユーザーDataSet.ユーザーRow, ユーザーDataSet.ユーザーDataTableKeys, ユーザーDataSet.ユーザーSearchCondition>.UpdateTable(ユーザーDataSet.ユーザーDataTable table)
		{
			this.Update(table);
		}

		void SampleApplication.BaseDataInterface.IBaseTableAdapterInterface<ユーザーDataSet.ユーザーDataTable, ユーザーDataSet.ユーザーRow, ユーザーDataSet.ユーザーDataTableKeys, ユーザーDataSet.ユーザーSearchCondition>.FillTableByKeys(ユーザーDataSet.ユーザーDataTable table, ユーザーDataSet.ユーザーDataTableKeys keys)
		{
			this.FillByKeys(table, keys.ID);
		}

		ユーザーDataSet.ユーザーDataTableKeys SampleApplication.BaseDataInterface.IBaseTableAdapterInterface<ユーザーDataSet.ユーザーDataTable, ユーザーDataSet.ユーザーRow, ユーザーDataSet.ユーザーDataTableKeys, ユーザーDataSet.ユーザーSearchCondition>.GetKeys(ユーザーDataSet.ユーザーRow row)
		{
			return new ユーザーDataSet.ユーザーDataTableKeys(row.ID);
		}

		void SampleApplication.BaseDataInterface.IBaseTableAdapterInterface<ユーザーDataSet.ユーザーDataTable, ユーザーDataSet.ユーザーRow, ユーザーDataSet.ユーザーDataTableKeys, ユーザーDataSet.ユーザーSearchCondition>.FillTableBySearch(ユーザーDataSet.ユーザーDataTable table, ユーザーDataSet.ユーザーSearchCondition condition)
		{
			this.FillBySearch(table,
				condition.姓, condition.名, condition.ユーザー名,
				condition.都道府県, condition.市町村, condition.電話番号);
		}

		#endregion

		#region IBaseTableAdapterInterface<DataTable,DataRow,DataTableKeys,SearchCondition> メンバ

		void IBaseTableAdapterInterface<DataTable, DataRow, DataTableKeys, SearchCondition>.FillTable(DataTable table)
		{
			this.Fill((ユーザーDataSet.ユーザーDataTable)table);
		}

		void IBaseTableAdapterInterface<DataTable, DataRow, DataTableKeys, SearchCondition>.UpdateTable(DataTable table)
		{
			this.Update((ユーザーDataSet.ユーザーDataTable)table);
		}

		void IBaseTableAdapterInterface<DataTable, DataRow, DataTableKeys, SearchCondition>.FillTableByKeys(DataTable table, DataTableKeys keys)
		{
			this.FillByKeys((ユーザーDataSet.ユーザーDataTable)table, ((ユーザーDataSet.ユーザーDataTableKeys)keys).ID);
		}

		DataTableKeys IBaseTableAdapterInterface<DataTable, DataRow, DataTableKeys, SearchCondition>.GetKeys(DataRow row)
		{
			return new ユーザーDataSet.ユーザーDataTableKeys(((ユーザーDataSet.ユーザーRow)row).ID);
		}

		void IBaseTableAdapterInterface<DataTable, DataRow, DataTableKeys, SearchCondition>.FillTableBySearch(DataTable table, SearchCondition condition)
		{
			ユーザーDataSet.ユーザーSearchCondition _condition = (ユーザーDataSet.ユーザーSearchCondition)condition;
			this.FillBySearch((ユーザーDataSet.ユーザーDataTable)table,
				_condition.姓, _condition.名, _condition.ユーザー名,
				_condition.都道府県, _condition.市町村, _condition.電話番号);
		}

		#endregion
	}
}