﻿using System;
using System.Data;
using System.Windows.Forms;

namespace SampleApplication.DataHelper
{
	class DataRowHelper
	{
		/// <summary>
		/// 一覧データの現在行を取得します
		/// </summary>
		/// <returns>現在行のDataRow　DataRow</returns>
		public static DataRow GetCurrentRow(DataGridView grid)
		{
			if (grid == null) throw new ArgumentNullException("grid");

			if (grid.CurrentRow == null) return null;
			DataRowView rowview = grid.CurrentRow.DataBoundItem as DataRowView;
			if (rowview == null) return null;
			return rowview.Row;
		}

		/// <summary>
		/// BindingSourceの現在行を取得します
		/// </summary>
		/// <returns>現在行のDataRow　DataRow</returns>
		public static DataRow GetCurrentRow(BindingSource bidingSource)
		{
			if (bidingSource == null) throw new ArgumentNullException("bidingSource");

			if (bidingSource.Current == null) return null;
			DataRowView rowview = bidingSource.Current as DataRowView;
			if (rowview == null) return null;
			return rowview.Row;
		}
	}
}
